#include "ARMCFunctions.h"
// Bitorderreversal for CMM2 v1.01 
// needs ~18us @400Mhz
// Usage: CSUB BitOrderReverse(nInput, nBits, RetValue)
// CSUB BitOrderReverse integer, integer, integer

void Bitorderreverse(long long *orig, long long *nbits, long long *reversed)
{
int i       = 1;
int n       = *nbits;
long long r = 0;
long long o = *orig;
unsigned long long bit_mask = 1; 

for(;i<=n;i++)
	{
	if ((o & (bit_mask<<(i-1))) > 0)
		r += bit_mask<<(n-i);
	}
*reversed=r;
}